/*----------------------------------------------------------------------------
 *      
 *----------------------------------------------------------------------------
 *      Name:    DEBUG.H
 *      Purpose: Debug Interface Functions
 *---------------------------------------------------------------------------*/

#ifndef __DEBUG_H_INCLUDED__
#define __DEBUG_H_INCLUDED__

#define NMI_HANDLER  						0x0001
#define HARDFAULT_HANDLER  			0x0002
#define MEMMANGE_HANDLER 				0x0003
#define USAGEFAULTHANDLER       0x0004
#define BUSFAULTHANDLER 				0x0005


#include "fault_handler.h"

#define set_modemled(change)           (((change) == 0) ? (PORT5->OUT |= 0x0004) : (PORT5->OUT &= ~(0x0004)))  // P5.2 
#define set_linkled(change)            (((change) == 0) ? (PORT2->OUT |= 0x0100) : (PORT2->OUT &= ~(0x0100)))  // P2.8 

extern void RSE_Softwarereset(void);
#define SOFTWARERESET 	RSE_Softwarereset() //NVIC_SystemReset()

// ISR_SW_PANIC: reset_handler must have been called before (@see Generic_Fault_Handler())
#define _ISR_SW_PANIC(type) { \
	SOFTWARERESET; \
}

#define _SW_PANIC(type) { \
	SOFTWARERESET; \
}

#endif // __DEBUG_H_INCLUDED__
