//****************************************************************************
// @Module        common_fuctions
// @Filename      common_functions.C
// @Project       e10k.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC164CS-16F
//
// @Compiler      Keil
//
// @Codegenerator 2.7
//
// @Description   Allgemeine Funktionen
//
//----------------------------------------------------------------------------
// @Date          24.06.2004 22:24:41
//
//****************************************************************************

#include <basic_typedef.h>
#include <common_functions.h>

/*===========================================================================*/
/* Name   : minimium ( UCHR x, UCHR y)                                       */
/* Berechnet das Minimum von zwei UCHR Werten                                */
/*===========================================================================*/
UINT16 minimum_uint (UINT16 x, UINT16 y) {
  if (x < y) return x;
  return y;
}

/*===========================================================================*/
/* Name   : SwapW1 ( unsigned long dw32)                                     */
/* U32 Wortweise austauschen                                                 */
/*===========================================================================*/
unsigned long SwapW1 (unsigned long dw32) {
	#if defined __ARMCC_VERSION || defined(_WIN32)
		// 0xB3B2B1B0 -> 0xB0B1B2B3
		//return dw32 << 8; 
		return ((dw32 & 0xFF) << 24) | (((dw32 >> 8) & 0xFF) << 16) | (((dw32 >> 16) & 0xFF) << 8) | ((dw32 >> 24) & 0xFF);
	#else
		__asm {
			MOV R1, R8
			MOV R2, R9
			MOVB RL4, RH2
			MOVB RH4, RL2
			MOVB RL5, RH1
			MOVB RH5, RL1
		}
	#endif
}

