/*----------------------------------------------------------------------------
 *      TAS 400
 *----------------------------------------------------------------------------
 *      Name:    FLASHA25L032.H
 *      Purpose: Software fr Flash A25L032
 *      Rev.:    V1.00
 *----------------------------------------------------------------------------*/
 
#ifndef __FLASHA25L032_H
#define __FLASHA25L032_H

#include "basic_typedef.h"
#include "common_functions.h"

/*--------------------------------------------------------------------------*/
/* Blockgren                                                              */                  
/*--------------------------------------------------------------------------*/
#define A25PAGESIZE (256)
#define A25SECTSIZE (4096)

/*--------------------------------------------------------------------------*/
/* SPI-Commands                                                             */                  
/*--------------------------------------------------------------------------*/
#define A25WREN  (0x06)
#define A25WRDI  (0x04)
#define A25RDSR1 (0x05)
#define A25RDSR2 (0x35)
#define A25EWRSR  (0x50) // Enable Write-Status-Register
#define A25WRSR  (0x01) // Write-Status-Register
#define A25ULBPR  (0x98) // Global Block-Protection Unlock (SST26VF032B)

#define A25RD (0x03)
#define A25PP (0x02)
#define A25CE (0x60)
#define A25SE (0x20)

#define A25RDID (0x9F)

#define A25READADDRESS(x) (A25RD | SwapW1(x))
#define A25SECTERASE(x)   (A25SE | SwapW1(x))
#define A25PRPAGE(x)      (A25PP | SwapW1(x))
#endif

/*----------------------------------------------------------------------------
 * end of file
 *---------------------------------------------------------------------------*/
