/*
 * Main.c
 *
 *  Created on: 14.02.2015
 *      Author: ibuchbauer
 */

#include <stdio.h>
#include "basic_typedef.h"
#include "DMA/DMA.h"
#include "CCU4/CCU4.h"
#include "USIC/U0C0_SPI_Memory.h"
#include "cflash_at28c256.h"

#pragma arm section rwdata="EEDATA_CONTENT",zidata="EEDATA_CONTENT"
volatile UINT8 g_ui8EEData_Content[0x20000] __attribute__((zero_init));
#pragma arm section rwdata,zidata // back to default

UCHR g_poweron_reset = FALSE;
UCHR g_cpu_rst_type = 0;
volatile UINT32 g_ui32ReloadCnt = 0;

extern void USIC0_vInit (void);
extern void NVICInit(void);

int main (void) {
	volatile UINT32 ui32Idx;
	volatile UINT32 ui32Idx2;
	UINT8	ui8LedVal = FALSE;
	
	// Disable watchdog
	WDT->CTR = 0;
	
	/* Disable Division by zero trap - SCB_CCR.DIV_0_TRP = 0 */
  SCB->CCR &= ~(SCB_CCR_DIV_0_TRP_Msk);
	
	NVICInit();	
	USIC0_vInit();
	vInitCCU4 (); // Starts 2 CCU-based Timer-Interrupts
	InitGPDMA0 ();
	U0C0_SPI_vInit ();

	g_poweron_reset = ((SCU_RESET->RSTSTAT) & SCU_RESET_RSTSTAT_HIBRS_Msk) 
		|| (((SCU_RESET->RSTSTAT) & SCU_RESET_RSTSTAT_RSTSTAT_Msk) & (0x01/*PORST*/));
	g_cpu_rst_type = (SCU_RESET->RSTSTAT & SCU_RESET_RSTSTAT_RSTSTAT_Msk); 
	SCU_RESET->RSTCLR = 0x01 << SCU_RESET_RSTCLR_RSCLR_Pos;
		
	set_modemled(FALSE);
	set_linkled(FALSE);

	while(1)
	{
		// Load data from SPI-connected nonvolatile memory to external RAM
		reload_eeprom_data();
		
		g_ui32ReloadCnt++;
		set_modemled(ui8LedVal);
		ui8LedVal = !ui8LedVal;
	}
}
