//****************************************************************************
// @Module        USIC0 Channel0 SPI Module (Memory)
// @Filename      U0C0_SPI_Memory.h
// @Project       XMC4500 TAS400 CPU
//----------------------------------------------------------------------------
//
// @Description   This file contains functions that use the U0C0 Module.
//
//----------------------------------------------------------------------------
// @Date          13.05.2015 
//
//****************************************************************************

#ifndef _U0C0_SPI_Memory_h_
#define _U0C0_SPI_Memory_h_
#include "basic_typedef.h"

#define SPI_ADRESSE_EEPROM1 0 // History + Datenbuffer
#define SPI_ADRESSE_EEPROM2 1 // TODO. Profile
#define SPI_ADRESSE_EEPROM3 2	// Reserve
#define SPI_ADRESSE_FRAM1 3		// Parametrierdaten (serieller_flash_datenverwaltung) (Namenstexte, SMS-Texte, etc.)
#define SPI_ADRESSE_FRAM2 4		// EEPROM-Emulation (eepoke)

#define SPI_SENDBUFFERSIZE 1024 // serieller_flash_driver.c max Write Data (256+4), FRAM -> max 1024 software limit
#define SPI_RECBUFFERSIZE  140

extern UCHR spi_sendbuffer[SPI_SENDBUFFERSIZE];
extern UCHR spi_recbuffer [SPI_RECBUFFERSIZE];

typedef struct spi_sendbuffer_struct {
  UCHR *sendbuffer;
  UCHR *recbuffer; 
} spi_sendbuffer_struct;


typedef struct spi_debug_struct {
  UINT sendeinterrupts;
  UINT32 empfangsinterrupts;
  UINT alternate_empfangsinterrupts;
  UINT fehlerinterrupts;
  UINT empfangsfehlerinterrupts;
  UINT phasenfehlerinterrupts;
	UINT32 ui32RxCnt;
	UINT32 ui32TxCnt;
} spi_debug_struct;


// just to be called once at startup
extern void U0C0_SPI_vInit (void);

extern UCHR write_to_spi (UCHR cs, void *cmd, UINT send_length, void *answ, UINT rec_length);

#endif
