#ifndef _FAULT_HANDLER_H
#define _FAULT_HANDLER_H

typedef struct stackframe_struct {
	unsigned long stacked_r0;              // General Purpose Register R0
	unsigned long stacked_r1;              // General Purpose Register R1
	unsigned long stacked_r2;              // General Purpose Register R2
	unsigned long stacked_r3;              // General Purpose Register R3
	unsigned long stacked_r12;             // General Purpose Register R12
	unsigned long stacked_lr;              // Link Register (Return Address)
	unsigned long stacked_pc;              // Progam Counter bei dem der Trap ausgelst wurde 
	unsigned long stacked_psr;             // Program Status Register
	unsigned long cfsr;                    // Fault Status Register siehe Seite 2-75 XMC4500 Manual
	unsigned long bus_fault_address;       // Adresse auf die beim Bus Fault Zugegriffen wurde  
	unsigned long memmanage_fault_address; // Adresse auf die beim Memmanage Fault Zugegriffen wurde
} stackframe_struct_t;

extern volatile stackframe_struct_t g_stack_frame;

extern void set_sw_reset_type (unsigned int type, unsigned long curr_pc, unsigned long curr_lr);
extern void SW_Reset_Handler(UINT32 ui32PC, UINT32 ui32LR);

extern void generate_stack_trace(const uint32_t stack[], uint32_t err_type, UINT32 ui32PC, UINT32 ui32LR);
extern void generate_trap_file(char* strTmpBuf, UINT32 uiBufLen);

extern void init_stack_trace_data(void);

#endif // _FAULT_HANDLER_H
